<?php

namespace Modules\Main\Http\Controllers\Company;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Modules\Main\Models\Company\Company;
use Modules\Main\Models\Company\CompanyAdmin;
use Modules\User\Models\User;

use App\Notifications\UserRegistered;


class CreateAdminController extends Controller
{
    public function __invoke(Request $request)
    {
        $company = Company::findOrFail($request->company_id);
        if ($request->user()->cannot('update', $company))
        {
            abort(403, 'Unauthorized action');
        }

        $user = User::where('email', $request->email)->orWhere('phone', $request->phone)->first();
        if ($user)
        {
            if ($user->id !== auth()->id()) //если это не текущий пользователь-админ, который хочет себя сделать агентом, то ошибка
            {
                if (CompanyAdmin::where('user_id', $user->id)->count()) // и если этот пользователь уже админ
                {
                    return back()->with('error', __('Admin is not unique'));
                }
            }
        }
        else
        {
            $user = $user = User::create($request->all());
        }

        if ($user)
        {
            CompanyAdmin::where('user_id', $user->id)->delete(); //на случай, если где-то этот пользователь уже был админом
            $agent = CompanyAdmin::create([
                'user_id'    => $user->id,
                'company_id' => $company->id
            ]);
        }

        if ($request->sendToEmail)
        {
            $user->setForcedPassword();
        }
        else
        {
            $password = $user->setForcedPassword(false);
            return back()->with('success', 'Пароль для пользователя установлен: ' . $password);
        }
        return back();
    }
}
